<?php
// $Id: actions.inc,v 1.1.2.3 2008/02/15 17:08:41 jbrown Exp $

// Copyright 2008 Jonathan Brown


function _op_video_append_actions_fieldset(&$form) {
	$content_type_info = _content_type_info();
	
	$fields = $content_type_info['content types'][$form['#node_type']->type]['fields'];

	if(is_array($fields)) {
		foreach($fields as $field) {
			if($field['type'] == 'op_video') {
				$append = TRUE;
				break;
			}
		}
	}
	
	if(!$append)
		return;
	
	actions_synchronize();
	
	$result = db_query("
		SELECT aid, description
		FROM {actions}
		WHERE type = 'node'
	");
	
	if(db_num_rows($result) == 0)
		return;
	
	while($action = db_fetch_array($result)) {
		$node_actions[$action['aid']] = $action['description'];
	}

	$form['op_video'] = array(
		'#type' => 'fieldset',
		'#tree' => TRUE,
		'#title' => t('Video'),
		'#collapsible' => TRUE,
		'#collapsed' => TRUE
 	);
 	
	$actions = variable_get('op_video_once_transcoded_actions', array());
	$description  = 'The selected actions will be fired once all videos in the node have been ';
	$description .= 'successfully transcoded.';
	
 	$form['op_video']['once_transcoded_actions'] = array(
		'#type' => 'select',
		'#title' => t("'Once transcoded' actions"),
		'#options' => $node_actions,
		'#multiple' => TRUE,
		'#default_value' => $actions[$form['#node_type']->type],
		'#description' => t($description)
	);
	
	$form['#submit']['_op_video_node_type_form_form_submit'] = array();
}


function _op_video_node_type_form_form_submit($form_id, &$form_values) {

	if($form_values['op'] != t('Save content type'))
		return;

	$actions = variable_get('op_video_once_transcoded_actions', array());
	$actions[$form_values['type']] = $form_values['op_video']['once_transcoded_actions'];
	variable_set('op_video_once_transcoded_actions', $actions);
	
	unset($form_values['op_video']);	// this doesn't work - node.module still creates a stupid variable
}


function _op_video_do_transcoding_actions($video_id) {

	$nid = db_result(db_query("
		SELECT nid
		FROM {op_videos}
		WHERE video_id = %d
	",
		$video_id
	));

	if(db_result(db_query("
		SELECT COUNT(*)
		FROM {op_videos}
		WHERE {op_videos}.nid = %d
			AND {op_videos}.flv_file_id IS NULL
	",
		$nid
	))) {
		return;
	}
	
	$node = node_load($nid);
	
	if(!$node)
		return;
	
	$actions = variable_get('op_video_once_transcoded_actions', array());
	actions_do($actions[$node->type], $node);
}

