<?php
// $Id: token.inc,v 1.1.2.4 2008/01/23 15:26:19 jbrown Exp $

// Copyright 2007-2008 Jonathan Brown


function op_video_token_values($type, $object = NULL) {
	$values = array();

	if($type == 'field' || $type == 'all') {
		$video = _op_video_load($object[0]['video_id']);
		
		$values['duration'] = $video['duration'] ? 
			format_interval($video['duration']) : '';
		
		$values['views'] = $video['flv_file'] != NULL ? 
			$video['views'] . ' ' . format_plural($video['views'], 'view', 'views') : '';
			
		$values['views_completed'] = $video['flv_file'] != NULL ? 
			$video['views_completed'] . ' complete ' . format_plural($video['views'], 'view', 'views') : '';
			
		$values['downloads'] = $video['downloads'] != NULL ? 
			$video['downloads'] . ' ' . format_plural($video['downloads'], 'download', 'downloads') : '';

		$values['filename'] = $video['source_file']['filename'] ? 
			$video['source_file']['filename'] : '';
			
		$values['filemime'] = $video['source_file']['filemime'] ? 
			$video['source_file']['filemime'] : '';
		
		$values['filesize'] = $video['source_file']['filesize'] ?
			_op_video_format_bytesize($video['source_file']['filesize'], 2) : '';
	
		$values['download'] = $video['source_file'] && !$video['source_file']['deleted'] ? 
			l('Download', _op_video_download_path($video)) : '';
	}
	
	return $values;
}


function op_video_token_list($type = 'all') {
	$list = array();

	if($type == 'field' || $type == 'all') {
    $list['Video']['duration'] = t("Video duration");
		$list['Video']['views'] = t("Views");
		$list['Video']['views_completed'] = t("Complete views");
		$list['Video']['downloads'] = t("Downloads");
		$list['Video']['filename'] = t("Filename");
		$list['Video']['filemime'] = t("File MIME");
		$list['Video']['filesize'] = t("File size");
		$list['Video']['download'] = t("Download link");
	}

	return $list;
}

